window.MultipleChoiceTestData = (function() {
    // Schon erzeugte Zufallszahlen
    var rands = [];
    // Zahl nach Vorgabe erzeugen
    function getNumber(
        boolRandom,     // Zufällige Zahl (true) oder Null (false)
        negative,       // Soll die Zahl negativ sein?
        showSign        // Unnötige Vorzeichen explizit anzeigen?
    ) {
        if (!boolRandom)
            return 0;
        return buildNumber(getRandomDigits(), negative, showSign);
    }

    // Aus Betrag, Vorzeichen und Anzeigeart für Vorzeichen eine Zahl zusammenbauen
    function buildNumber(
        abs,            // Betrag der Zahl
        negative,       // Soll die Zahl negativ sein?
        showSign        // Unnötige Vorzeichen explizit anzeigen?
    ) {
        return (negative ? '-' : (showSign ? '+' : '')) + abs;
    }

    // Zufällige Ziffernfolge erstellen
    function getRandomDigits() {
        var r;
        //do {
            r = Math.floor(Math.random() * 20) + 1;
        //} while (rands.indexOf(r) != -1);
        rands.push(r);
        return r;
    }

    // Zufällig eine Zahl erzeugen
    function getRandomNumber() {
        switch(Math.floor(Math.random() * 13)) {
            case 0:
            case 1:
            case 5:
            case 6:
            case 10:
            case 12:
                return getNumber(true, true, true);
            case 2:
                return '0';
            case 3:
            case 4:
            case 11:
                return getNumber(true, false, true);
            case 7:
            case 8:
            case 9:
                return getNumber(true, false, false);
        }
    }

    // Vorzeichen ermitteln
    function sgn(
        number      // Fragliche Zahl
    ) {
        return (number == 0) ? 0 : ((number > 0) ? +1 : -1);
    }

    var data = {
        // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
        "maxTries": Infinity,

        // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
        "reportScore": false,

        // Optional: Sollen die Fragen nicht durchgemischt werden?
        "keepOrder": false,

        // Optional: Wie soll bewertet werden?
        // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
        // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
        // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
        "countMode": "questions",

        // Wie viele Fragen sollen für einen Test gezogen werden?
        "questionsPerTest": 6,

        // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
        "threshold": 1,

        // Optional: Begrüßungstext
        "htmlIntro": "<p>Berechne alle Produktwerte richtig, um das Lernpaket abzuschließen.</p>",

        // Verfügbare statische Fragen
        "questions": [],

        // Fragengeneratoren
        "generators": []
    };

    // Eine Multiplikationsaufgabe
    data.generators.push(function(arrFragen) {
        var s1 = getRandomNumber();
        var s2 = getRandomNumber();
        var t = s1;
        if ((['+', '-'].indexOf(s1.charAt(0)) != -1))
            t = "(" + s1 + ')';
        t += ' · ' + ((['+', '-'].indexOf(s2.charAt(0)) == -1) ? s2 : ('(' + s2 + ')')) + ' = ';
        frage = {
            "html": "Berechne:",
            "singlechoice": true,
            "choices": [
                { "html": "<code>" + t + "</code>", "type": "number", "step": 1, "accept": (+s1 * (+s2)), "correct": true, "size": 2 }
            ]
        };
        arrFragen.push(frage);
    });

    // Statt einer Multiplikationsaufgabe gleich mehrere erzeugen
    data.generators[0] = (function(gen) {
        return function(arrFragen) {
            for (var z = data.questionsPerTest; z; --z)
                gen.call(this, arrFragen);
        };
    })(data.generators[0]);

    return data;
})();
